=== modified file 'Makefile.am'
--- Makefile.am	2012-01-10 09:31:10 +0000
+++ Makefile.am	2012-08-30 11:06:25 +0000
@@ -1,6 +1,6 @@
 # -*- Mode: Automake; indent-tabs-mode: t; tab-width: 4 -*-
 
-SUBDIRS = data po src
+SUBDIRS = data po src tests
 
 EXTRA_DIST = \
 	autogen.sh \

=== modified file 'configure.ac'
--- configure.ac	2012-08-22 18:40:53 +0000
+++ configure.ac	2012-08-30 11:06:25 +0000
@@ -50,5 +50,6 @@
 data/Makefile
 po/Makefile.in
 src/Makefile
+tests/Makefile
 ])
 AC_OUTPUT

=== modified file 'src/greeter-list.vala'
--- src/greeter-list.vala	2012-08-27 22:30:33 +0000
+++ src/greeter-list.vala	2012-08-30 11:06:25 +0000
@@ -176,7 +176,7 @@
 
     public void cancel_authentication ()
     {
-        UnityGreeter.greeter.cancel_authentication ();
+        UnityGreeter.singleton.cancel_authentication ();
         entry_selected (selected_entry.id);
     }
 
@@ -211,7 +211,7 @@
     protected void add_with_class (Gtk.Widget widget)
     {
         fixed.add (widget);
-        UnityGreeter.add_style_class (widget);
+        UnityGreeter.singleton.add_style_class (widget);
     }
 
     protected void redraw_greeter_box ()
@@ -699,9 +699,9 @@
 
     protected void connect_to_lightdm ()
     {
-        UnityGreeter.greeter.show_message.connect (show_message_cb);
-        UnityGreeter.greeter.show_prompt.connect (show_prompt_cb);
-        UnityGreeter.greeter.authentication_complete.connect (authentication_complete_cb);
+        UnityGreeter.singleton.show_message.connect (show_message_cb);
+        UnityGreeter.singleton.show_prompt.connect (show_prompt_cb);
+        UnityGreeter.singleton.authentication_complete.connect (authentication_complete_cb);
     }
 
     protected void show_message_cb (string text, LightDM.MessageType type)
@@ -714,10 +714,10 @@
         /* Notify the greeter on what user has been logged */
         if (get_selected_id () == "*other" && manual_name == null)
         {
-            if (UnityGreeter.test_mode)
+            if (UnityGreeter.singleton.test_mode)
                 manual_name = test_username;
             else
-                manual_name = UnityGreeter.greeter.authentication_user;
+                manual_name = UnityGreeter.singleton.authentication_user();
         }
 
         prompted = true;
@@ -743,10 +743,10 @@
             return;
 
         bool is_authenticated;
-        if (UnityGreeter.test_mode)
+        if (UnityGreeter.singleton.test_mode)
             is_authenticated = test_is_authenticated;
         else
-            is_authenticated = UnityGreeter.greeter.is_authenticated;
+            is_authenticated = UnityGreeter.singleton.is_authenticated();
 
         if (is_authenticated)
         {
@@ -754,7 +754,7 @@
             if (prompted)
             {
                 login_complete ();
-                if (UnityGreeter.test_mode)
+                if (UnityGreeter.singleton.test_mode)
                     start_session ();
                 else
                 {
@@ -806,16 +806,16 @@
 
         greeter_authenticating_user = get_selected_id ();
 
-        if (UnityGreeter.test_mode)
+        if (UnityGreeter.singleton.test_mode)
             test_start_authentication ();
         else
         {
             if (get_selected_id () == "*other")
-                UnityGreeter.greeter.authenticate ();
+                UnityGreeter.singleton.authenticate ();
             else if (get_selected_id () == "*guest")
-                UnityGreeter.greeter.authenticate_as_guest ();
+                UnityGreeter.singleton.authenticate_as_guest ();
             else
-                UnityGreeter.greeter.authenticate (get_selected_id ());
+                UnityGreeter.singleton.authenticate (get_selected_id ());
         }
     }
 
@@ -834,7 +834,7 @@
         background.draw_grid = false;
         background.queue_draw ();
 
-        UnityGreeter.start_session (get_lightdm_session ());
+        UnityGreeter.singleton.start_session (get_lightdm_session ());
     }
 
     public void login_complete ()

=== modified file 'src/menubar.vala'
--- src/menubar.vala	2012-08-27 22:30:33 +0000
+++ src/menubar.vala	2012-08-30 11:06:25 +0000
@@ -267,7 +267,7 @@
         }
         keyboard_label.label = desc;
 
-        if (UnityGreeter.test_mode)
+        if (UnityGreeter.singleton.test_mode)
             debug ("Setting layout to %s", layout.name);
         else
             LightDM.set_layout (layout);

=== modified file 'src/session-list.vala'
--- src/session-list.vala	2012-08-27 23:02:51 +0000
+++ src/session-list.vala	2012-08-30 11:06:25 +0000
@@ -1,3 +1,4 @@
+
 /* -*- Mode: Vala; indent-tabs-mode: nil; tab-width: 4 -*-
  *
  * Copyright (C) 2012 Canonical Ltd
@@ -33,7 +34,7 @@
     {
         label = _("Select desktop environment");
 
-        if (UnityGreeter.test_mode)
+        if (UnityGreeter.singleton.test_mode)
         {
             add_session ("gnome", "GNOME");
             add_session ("kde", "KDE");

=== modified file 'src/unity-greeter.vala'
--- src/unity-greeter.vala	2012-08-29 14:12:26 +0000
+++ src/unity-greeter.vala	2012-08-30 11:06:25 +0000
@@ -21,8 +21,9 @@
 
 public class UnityGreeter
 {
-    static bool show_version = false;
     public static bool test_mode = false;
+    private static Timer log_timer;
+    private static bool show_version = false;
     public static const OptionEntry[] options =
     {
         { "version", 'v', 0, OptionArg.NONE, ref show_version,
@@ -34,24 +35,35 @@
         { null }
     };
 
-    private static Timer log_timer;
-
-    private static string state_file;
-    private static KeyFile state;
-
-    private static Cairo.XlibSurface background_surface;
+    public signal void show_message (string text, LightDM.MessageType type);
+    public signal void show_prompt (string text, LightDM.PromptType type);
+    public signal void authentication_complete ();
+
+    private string state_file;
+    private KeyFile state;
+
+    private Cairo.XlibSurface background_surface;
 
     private SettingsDaemon settings_daemon;
 
-    private static MainWindow main_window;
+    private MainWindow main_window;
 
-    public static LightDM.Greeter greeter;
+    private LightDM.Greeter greeter;
 
     private Canberra.Context canberra_context;
 
-    public UnityGreeter ()
+    public static UnityGreeter singleton;
+
+    private UnityGreeter ()
     {
+        /* Prepare to set the background */
+        debug ("Creating background surface");
+        background_surface = create_root_surface (Gdk.Screen.get_default ());
+
         greeter = new LightDM.Greeter ();
+        greeter.show_message.connect ((text, type) => { show_message (text, type); });
+        greeter.show_prompt.connect ((text, type) => { show_prompt (text, type); });
+        greeter.authentication_complete.connect (() => { authentication_complete (); });
         var connected = false;
         try
         {
@@ -91,7 +103,7 @@
         Gdk.threads_add_idle (ready_cb);
     }
 
-    public static string? get_state (string key)
+    public string? get_state (string key)
     {
         try
         {
@@ -103,7 +115,7 @@
         }
     }
 
-    public static void set_state (string key, string value)
+    public void set_state (string key, string value)
     {
         state.set_value ("greeter", key, value);
         var data = state.to_data ();
@@ -117,12 +129,12 @@
         }
     }
 
-    public static void push_list (GreeterList widget)
+    public void push_list (GreeterList widget)
     {
         main_window.push_list (widget);
     }
 
-    public static void pop_list ()
+    public void pop_list ()
     {
         main_window.pop_list ();
     }
@@ -144,12 +156,12 @@
         return null;
     }
 
-    public static void start_session (string? session)
+    public void start_session (string? session)
     {
         /* Set the background */
         refresh_background (Gdk.Screen.get_default (), background_surface);
 
-        if (UnityGreeter.test_mode)
+        if (test_mode)
         {
                 debug ("Successfully logged in!  Quitting...");
                 Gtk.main_quit ();
@@ -158,7 +170,7 @@
         {
             try
             {
-                UnityGreeter.greeter.start_session_sync (session);
+                greeter.start_session_sync (session);
             }
             catch (Error e)
             {
@@ -192,7 +204,62 @@
         main_window.set_keyboard_state ();
     }
 
-    private static Gdk.FilterReturn focus_upon_map (Gdk.XEvent gxevent, Gdk.Event event)
+    public bool is_authenticated ()
+    {
+        return greeter.is_authenticated;
+    }
+
+    public void authenticate (string? userid = null)
+    {
+        greeter.authenticate (userid);
+    }
+
+    public void authenticate_as_guest ()
+    {
+        greeter.authenticate_as_guest ();
+    }
+
+    public void cancel_authentication ()
+    {
+        greeter.cancel_authentication ();
+    }
+
+    public void respond (string response)
+    {
+        greeter.respond (response);
+    }
+
+    public string authentication_user ()
+    {
+        return greeter.authentication_user;
+    }
+
+    public string default_session_hint ()
+    {
+        return greeter.default_session_hint;
+    }
+
+    public string select_user_hint ()
+    {
+        return greeter.select_user_hint;
+    }
+
+    public bool show_manual_login_hint ()
+    {
+        return greeter.show_manual_login_hint;
+    }
+
+    public bool hide_users_hint ()
+    {
+        return greeter.hide_users_hint;
+    }
+
+    public bool has_guest_account_hint ()
+    {
+        return greeter.has_guest_account_hint;
+    }
+
+    private Gdk.FilterReturn focus_upon_map (Gdk.XEvent gxevent, Gdk.Event event)
     {
         var xevent = (X.Event*)gxevent;
         if (xevent.type == X.EventType.MapNotify)
@@ -344,10 +411,6 @@
         debug ("Setting cursor");
         Gdk.get_default_root_window ().set_cursor (new Gdk.Cursor (Gdk.CursorType.LEFT_PTR));
 
-        /* Prepare to set the background */
-        debug ("Creating background surface");
-        background_surface = create_root_surface (Gdk.Screen.get_default ());
-
         debug ("Loading command line options");
         var c = new OptionContext (/* Arguments and description for --help text */
                                    _("- Unity Greeter"));
@@ -412,10 +475,10 @@
             settings.set ("gtk-xft-rgba", value, null);
 
         debug ("Creating Unity Greeter");
-        var greeter = new UnityGreeter ();
+        UnityGreeter.singleton = new UnityGreeter ();
 
         debug ("Showing greeter");
-        greeter.show ();
+        UnityGreeter.singleton.show ();
 
         debug ("Starting main loop");
         Gtk.main ();

=== modified file 'src/user-list.vala'
--- src/user-list.vala	2012-08-28 13:38:05 +0000
+++ src/user-list.vala	2012-08-30 11:06:25 +0000
@@ -129,7 +129,7 @@
 
         connect_to_lightdm ();
 
-        if (!UnityGreeter.test_mode && UGSettings.get_boolean (UGSettings.KEY_ENABLE_REMOTE_LOGIN))
+        if (!UnityGreeter.singleton.test_mode && UGSettings.get_boolean (UGSettings.KEY_ENABLE_REMOTE_LOGIN))
             remote_login_service_watch = Bus.watch_name (BusType.SESSION,
                                             "com.canonical.RemoteLogin",
                                             BusNameWatcherFlags.AUTO_START,
@@ -372,7 +372,7 @@
             try
             {
                 var url = url_from_remote_loding_server_list_name (selected_entry.id);
-                if (UnityGreeter.test_mode)
+                if (UnityGreeter.singleton.test_mode)
                 {
                     if (password_field.text == "password")
                     {
@@ -445,7 +445,7 @@
         sensitive = false;
         will_clear = true;
         greeter_authenticating_user = selected_entry.id;
-        if (UnityGreeter.test_mode)
+        if (UnityGreeter.singleton.test_mode)
         {
             Gtk.Entry field = current_remote_fields.get ("password") as Gtk.Entry;
             test_is_authenticated = field.text == "password";
@@ -457,7 +457,7 @@
         else
         {
 #if HAVE_REMOTE_LIGHTDM
-            UnityGreeter.greeter.authenticate_remote (get_lightdm_session (), null);
+            UnityGreeter.singleton.greeter.authenticate_remote (get_lightdm_session (), null);
 #endif
             remote_login_service.set_last_used_server (currently_browsing_server_url, url_from_remote_loding_server_list_name (selected_entry.id));
         }
@@ -490,7 +490,7 @@
                 {
                     greeter_authenticating_user = selected_entry.id;
 #if HAVE_REMOTE_LIGHTDM
-                    UnityGreeter.greeter.authenticate_remote (config_session, null);
+                    UnityGreeter.singleton.greeter.authenticate_remote (config_session, null);
 #endif
                 }
             }
@@ -550,7 +550,7 @@
 
     private void entry_selected_cb (string? username)
     {
-        UnityGreeter.set_state ("last-user", username);
+        UnityGreeter.singleton.set_state ("last-user", username);
         if (selected_entry is UserPromptBox)
             session = (selected_entry as UserPromptBox).session;
         else
@@ -676,7 +676,7 @@
                         string[] email_domains;
                         try
                         {
-                            if (UnityGreeter.test_mode)
+                            if (UnityGreeter.singleton.test_mode)
                                 email_domains = { "canonical.com", "ubuntu.org", "candy.com", "urban.net" };
                             else
                                 yield remote_login_service.get_cached_domains_for_server (url, out email_domains);
@@ -766,10 +766,10 @@
 
         foreach (var response in responses)
         {
-            if (UnityGreeter.test_mode)
+            if (UnityGreeter.singleton.test_mode)
                 test_respond (response);
             else
-                UnityGreeter.greeter.respond (response);
+                UnityGreeter.singleton.respond (response);
         }
     }
 
@@ -778,10 +778,10 @@
         debug ("Start session for %s", selected_entry.id);
 
         var is_authenticated = false;
-        if (UnityGreeter.test_mode)
+        if (UnityGreeter.singleton.test_mode)
             is_authenticated = test_is_authenticated;
         else
-            is_authenticated = UnityGreeter.greeter.is_authenticated;
+            is_authenticated = UnityGreeter.singleton.is_authenticated();
 
         /* Finish authentication (again) or restart it */
         if (is_authenticated)
@@ -797,13 +797,13 @@
     {
         var session_chooser = new SessionList (background, menubar, session, default_session);
         session_chooser.session_clicked.connect (session_clicked_cb);
-        UnityGreeter.push_list (session_chooser);
+        UnityGreeter.singleton.push_list (session_chooser);
     }
 
     private void session_clicked_cb (string session)
     {
         this.session = session;
-        UnityGreeter.pop_list ();
+        UnityGreeter.singleton.pop_list ();
     }
 
     private Gdk.Pixbuf? get_badge ()
@@ -867,13 +867,13 @@
 
     private void fill_list ()
     {
-        if (UnityGreeter.test_mode)
+        if (UnityGreeter.singleton.test_mode)
             test_fill_list ();
         else
         {
-            default_session = UnityGreeter.greeter.default_session_hint;
-            always_show_manual = UnityGreeter.greeter.show_manual_login_hint;
-            if (!UnityGreeter.greeter.hide_users_hint)
+            default_session = UnityGreeter.singleton.default_session_hint ();
+            always_show_manual = UnityGreeter.singleton.show_manual_login_hint ();
+            if (!UnityGreeter.singleton.hide_users_hint ())
             {
                 var users = LightDM.UserList.get_instance ();
                 users.user_added.connect (user_added_cb);
@@ -883,15 +883,15 @@
                     user_added_cb (user);
             }
 
-            if (UnityGreeter.greeter.has_guest_account_hint)
+            if (UnityGreeter.singleton.has_guest_account_hint ())
             {
                 debug ("Adding guest account entry");
                 offer_guest = true;
             }
 
-            var last_user = UnityGreeter.get_state ("last-user");
-            if (UnityGreeter.greeter.select_user_hint != null)
-                set_active_entry (UnityGreeter.greeter.select_user_hint);
+            var last_user = UnityGreeter.singleton.get_state ("last-user");
+            if (UnityGreeter.singleton.select_user_hint () != null)
+                set_active_entry (UnityGreeter.singleton.select_user_hint ());
             else if (last_user != null)
                 set_active_entry (last_user);
         }
@@ -908,7 +908,7 @@
         var layouts = new List <LightDM.Layout> ();
         foreach (var name in user.get_layouts ())
         {
-            var layout = UnityGreeter.get_layout_by_name (name);
+            var layout = UnityGreeter.singleton.get_layout_by_name (name);
             if (layout != null)
                 layouts.append (layout);
         }
@@ -930,24 +930,24 @@
             {
                 Gtk.Entry field = current_remote_fields.get ("username") as Gtk.Entry;
                 var answer = field != null ? field.text : "";
-                UnityGreeter.greeter.respond (answer);
+                UnityGreeter.singleton.respond (answer);
             }
             else if (text == "password:")
             {
                 Gtk.Entry field = current_remote_fields.get ("password") as Gtk.Entry;
                 var answer = field != null ? field.text : "";
-                UnityGreeter.greeter.respond (answer);
+                UnityGreeter.singleton.respond (answer);
             }
             else if (text == "remote host:")
             {
                 var answer = url_from_remote_loding_server_list_name (selected_entry.id);
-                UnityGreeter.greeter.respond (answer);
+                UnityGreeter.singleton.respond (answer);
             }
             else if (text == "domain:")
             {
                 Gtk.Entry field = current_remote_fields.get ("domain") as Gtk.Entry;
                 var answer = field != null ? field.text : "";
-                UnityGreeter.greeter.respond (answer);
+                UnityGreeter.singleton.respond (answer);
             }
         }
         else
@@ -1048,7 +1048,7 @@
             return false;
         });
 
-        var last_user = UnityGreeter.get_state ("last-user");
+        var last_user = UnityGreeter.singleton.get_state ("last-user");
         if (last_user != null)
             set_active_entry (last_user);
 
@@ -1252,7 +1252,7 @@
         var layouts = new List <LightDM.Layout> ();
         foreach (var name in names_split)
         {
-            var layout = UnityGreeter.get_layout_by_name (name);
+            var layout = UnityGreeter.singleton.get_layout_by_name (name);
             if (layout != null)
                 layouts.append (layout);
         }

=== added directory 'tests'
=== added file 'tests/Makefile.am'
--- tests/Makefile.am	1970-01-01 00:00:00 +0000
+++ tests/Makefile.am	2012-08-30 11:06:25 +0000
@@ -0,0 +1,59 @@
+# -*- Mode: Automake; indent-tabs-mode: t; tab-width: 4 -*-
+
+noinst_PROGRAMS = unity-greeter-test
+
+unity_greeter_test_SOURCES = \
+	test.vala \
+	menubar.vala \
+	unity-greeter.vala \
+	../src/user-list.vala \
+	../src/greeter-list.vala \
+	../src/remote-login-service.vala \
+	../src/background.vala \
+	../src/email-autocompleter.vala \
+	../src/config.vapi \
+	../src/fixes.vapi \
+	../src/animate-timer.vala \
+	../src/indicator.vapi \
+	../src/fadable.vala \
+	../src/fadable-box.vala \
+	../src/dash-box.vala \
+	../src/user-prompt-box.vala \
+	../src/fading-label.vala \
+	../src/cached-image.vala \
+	../src/dash-entry.vala \
+	../src/dash-button.vala \
+	../src/prompt-box.vala \
+	../src/session-list.vala \
+	../src/main-window.vala \
+	../src/list-stack.vala \
+	../src/settings.vala
+
+
+unity_greeter_test_CFLAGS = \
+	$(UNITY_GREETER_CFLAGS) \
+	$(WARN_CFLAGS) \
+	-DGETTEXT_PACKAGE=\"$(GETTEXT_PACKAGE)\" \
+	-DLOCALEDIR=\""$(localedir)"\" \
+	-DVERSION=\"$(VERSION)\" \
+	-DCONFIG_FILE=\""$(sysconfdir)/lightdm/unity-greeter.conf"\" \
+	-DPKGDATADIR=\""$(pkgdatadir)"\" \
+	-DINDICATORDIR=\""$(INDICATORDIR)"\"
+
+unity_greeter_test_VALAFLAGS = \
+	--pkg posix \
+	$(HAVE_REMOTE_LIGHTDM_FLAGS) \
+	--pkg gtk+-3.0 \
+	--pkg gdk-x11-3.0 \
+	--pkg gio-unix-2.0 \
+	--pkg x11 \
+	--pkg liblightdm-gobject-1 \
+	--pkg libcanberra \
+	--pkg gio-2.0 \
+	--target-glib 2.32
+
+unity_greeter_test_LDADD = \
+	$(UNITY_GREETER_LIBS)
+
+DISTCLEANFILES = \
+	Makefile.in

=== added file 'tests/menubar.vala'
--- tests/menubar.vala	1970-01-01 00:00:00 +0000
+++ tests/menubar.vala	2012-08-30 11:06:25 +0000
@@ -0,0 +1,35 @@
+/* -*- Mode: Vala; indent-tabs-mode: nil; tab-width: 4 -*-
+ *
+ * Copyright (C) 2012 Canonical Ltd
+ *
+ * This program is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License version 3 as
+ * published by the Free Software Foundation.
+ *
+ * This program is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with this program.  If not, see <http://www.gnu.org/licenses/>.
+ *
+ */
+
+public class MenuBar : Gtk.MenuBar
+{
+    public static const int HEIGHT = 32;
+    public bool high_contrast { get; private set; default = false; }
+
+    public MenuBar (Background bg, Gtk.AccelGroup ag)
+    {
+    }
+
+    public void set_layouts (List <LightDM.Layout> layouts)
+    {
+    }
+
+    public void set_keyboard_state ()
+    {
+    }
+}

=== added file 'tests/test.vala'
--- tests/test.vala	1970-01-01 00:00:00 +0000
+++ tests/test.vala	2012-08-30 11:06:25 +0000
@@ -0,0 +1,29 @@
+
+public class Test
+{
+
+    public static void simple_test_case ()
+    {
+        MainWindow main_window = new MainWindow ();
+        main_window.show();
+//         UnityGreeter.singleton = new UnityGreeter();
+//         UnityGreeter.singleton.test_mode = true;
+//         Cairo.ImageSurface s = new Cairo.ImageSurface(Cairo.Format.ARGB32, 100, 100);
+//         Background bg = new Background (s);
+//         UserList *list = new UserList (bg, main_window.menubar);
+//         // a suitable test
+//         g_assert (g_bit_storage (1) == 1);
+//         // a test with verbose error message
+//         g_assert_cmpint (g_bit_storage (1), ==, 1);
+    }
+
+    public static int main (string[] args)
+    {
+        Gtk.test_init(args);
+
+        GLib.Test.add_func ("/Simple Test Case", simple_test_case);
+
+        return GLib.Test.run();
+    }
+
+}
\ No newline at end of file

=== added file 'tests/unity-greeter.vala'
--- tests/unity-greeter.vala	1970-01-01 00:00:00 +0000
+++ tests/unity-greeter.vala	2012-08-30 11:06:25 +0000
@@ -0,0 +1,119 @@
+/* -*- Mode: Vala; indent-tabs-mode: nil; tab-width: 4 -*-
+ *
+ * Copyright (C) 2011 Canonical Ltd
+ *
+ * This program is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License version 3 as
+ * published by the Free Software Foundation.
+ *
+ * This program is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with this program.  If not, see <http://www.gnu.org/licenses/>.
+ *
+ * Authored by: Robert Ancell <robert.ancell@canonical.com>
+ */
+
+public const int grid_size = 40;
+
+public class UnityGreeter
+{
+    public static UnityGreeter singleton;
+    public static bool test_mode = false;
+
+    public signal void show_message (string text, LightDM.MessageType type);
+    public signal void show_prompt (string text, LightDM.PromptType type);
+    public signal void authentication_complete ();
+
+    public bool is_authenticated ()
+    {
+        return false;
+    }
+
+    public void authenticate (string? userid = null)
+    {
+    }
+
+    public void authenticate_as_guest ()
+    {
+    }
+
+    public void cancel_authentication ()
+    {
+    }
+
+    public void respond (string response)
+    {
+    }
+
+    public string authentication_user ()
+    {
+        return "";
+    }
+
+    public string default_session_hint ()
+    {
+        return "";
+    }
+
+    public string select_user_hint ()
+    {
+        return "";
+    }
+
+    public bool show_manual_login_hint ()
+    {
+        return false;
+    }
+
+    public bool hide_users_hint ()
+    {
+        return false;
+    }
+
+    public bool has_guest_account_hint ()
+    {
+        return false;
+    }
+
+    public void start_session (string? session)
+    {
+    }
+
+    public void push_list (GreeterList widget)
+    {
+    }
+
+    public void pop_list ()
+    {
+    }
+
+    public string? get_state (string key)
+    {
+        return null;
+    }
+
+    public void set_state (string key, string value)
+    {
+    }
+
+    public static LightDM.Layout? get_layout_by_name (string name)
+    {
+        foreach (var layout in LightDM.get_layouts ())
+        {
+            if (layout.name == name)
+                return layout;
+        }
+        return null;
+    }
+
+    public static void add_style_class (Gtk.Widget widget)
+    {
+        /* Add style context class lightdm-user-list */
+        var ctx = widget.get_style_context ();
+        ctx.add_class ("lightdm");
+    }
+}

